/* Test der PWM-Lib für 3 Kanäle
 RGB-LED mit PWM steuern
 R an P0.0 (Tastgrad mit Poti0)
 G an P0.1 (Tastgrad mit Poti1)
 B an P0.2 (automatische Erhöhung und Erniedrigung des Tastgrads)
 */

#include <XMC1100-Lib.h>			// Hilfsfunktionen für XMC1100
uint8_t tg0,tg1,tg2,up;				// Tastgrade und Merker up/down

int main(void)						// Hauptprogramm
{
  port_init(P0,OUTP);				// Port0 auf Ausgabe, nicht notwendig für PWM
  pwm_init(0);						// PWM Kanal 0 initialisieren
  pwm_init(1);						// PWM Kanal 1 initialisieren
  pwm_init(2);						// PWM Kanal 1 initialisieren
  pwm_start(0);						// Ausgabe starten
  pwm_start(1);						// Ausgabe starten
  pwm_start(2);						// Ausgabe starten
  adc_init();						// ADC initialisieren
  lcd_init();						// LCD initialisieren
  tg2 = 0;							// Anfangswert Tastgrad2
  up = 1;							// Anfangswert
  while(1U)							// Endlosschleife, immer bei Controllern
  {
	  tg0 = adc_in(0)>>4;			// 8 Bit des 12-Bit-ADU-Wertes für Tastgrad0
	  tg1 = adc_in(1)>>4;			// 8 Bit des 12-Bit-ADU-Wertes für Tastgrad1
	  pwm_duty_cycle(0,tg0);		// Tastgrade
	  pwm_duty_cycle(1,tg1);
	  pwm_duty_cycle(2,tg2);
	  delay_ms(10);					// Zeit für Geschweindigkeit der automatischen Änderung
	  if (up==1) tg2++;				// Tastgrad größer
	  	  else tg2--;				// Tastgrad kleiner
	  if (tg2==0) up=1;				// Umschalten Tastgrad erhöhen/erniedrigen
	  if (tg2==255) up=0;
	  lcd_setcursor (1,1); lcd_print("R"); lcd_byte (tg0);	// LCD-Ausgabe der Tastgrade
	  lcd_setcursor (2,1); lcd_print("G"); lcd_byte (tg1);
	  lcd_setcursor (3,1); lcd_print("B"); lcd_byte (tg2);
  }//while
}//main

