/* Test der PWM-Lib für 3 Kanäle
 RGB-LED mit PWM steuern
 R an P0.0 (Tastgrad mit Poti0)
 G an P0.1 (Tastgrad mit Poti1)
 B an P0.2 (automatische Erhöhung und Erniedrigung des Tastgrads)
 */

#include <XMC1100-Lib.h>			// Hilfsfunktionen für XMC1100
uint8_t z;			// Zählvariable


void RGBout (uint8_t tgr,uint8_t tgg,uint8_t tgb)
{
	 pwm1_duty_cycle(~tgr);		// Tastgrade
	 pwm2_duty_cycle(~tgg);
	 pwm3_duty_cycle(~tgb);
}

int main(void)						// Hauptprogramm
{
  port_init(P0,OUTP);				// Port0 auf Ausgabe, nicht notwendig für PWM
  pwm1_init();						// PWM Kanal 0 initialisieren
  pwm2_init();						// PWM Kanal 1 initialisieren
  pwm3_init();						// PWM Kanal 1 initialisieren
  pwm1_start();						// Ausgabe starten
  pwm2_start();						// Ausgabe starten
  pwm3_start();						// Ausgabe starten
  while(1U)							// Endlosschleife, immer bei Controllern
  {
    for (z=0;z!=255;z++) {RGBout (z,0,0);delay_ms(10);}
    for (z=0;z!=255;z++) {RGBout (255,z,0);delay_ms(10);}
    for (z=0;z!=255;z++) {RGBout (~z,255,z);delay_ms(10);}
    for (z=0;z!=255;z++) {RGBout (0,~z,255);delay_ms(10);}
    for (z=0;z!=255;z++) {RGBout (z,z,~z);delay_ms(10);}
    for (z=0;z!=255;z++) {RGBout (~z,~z,0);delay_ms(10);}


  }//while
}//main

